import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { __decorate } from 'tslib';
import { createCustomElement } from '@angular/elements';
import { fromEvent } from 'rxjs';
import * as Components from '@profabric/web-components';

/* eslint-disable */
/* tslint:disable */
const proxyInputs = (Cmp, inputs) => {
    const Prototype = Cmp.prototype;
    inputs.forEach(item => {
        Object.defineProperty(Prototype, item, {
            get() {
                return this.el[item];
            },
            set(val) {
                this.z.runOutsideAngular(() => (this.el[item] = val));
            },
        });
    });
};
const proxyMethods = (Cmp, methods) => {
    const Prototype = Cmp.prototype;
    methods.forEach(methodName => {
        Prototype[methodName] = function () {
            const args = arguments;
            return this.z.runOutsideAngular(() => this.el[methodName].apply(this.el, args));
        };
    });
};
const proxyOutputs = (instance, el, events) => {
    events.forEach(eventName => (instance[eventName] = fromEvent(el, eventName)));
};
const defineCustomElement = (tagName, customElement) => {
    if (customElement !== undefined &&
        typeof customElements !== 'undefined' &&
        !customElements.get(tagName)) {
        customElements.define(tagName, customElement);
    }
};
// tslint:disable-next-line: only-arrow-functions
function ProxyCmp(opts) {
    const decorator = function (cls) {
        const { defineCustomElementFn, inputs, methods } = opts;
        if (defineCustomElementFn !== undefined) {
            defineCustomElementFn();
        }
        if (inputs) {
            proxyInputs(cls, inputs);
        }
        if (methods) {
            proxyMethods(cls, methods);
        }
        return cls;
    };
    return decorator;
}

let Badge = class Badge {
    constructor(c, r, z, injector) {
        this.z = z;
        this.injector = injector;
        c.detach();
        this.el = r.nativeElement;
    }
    ngDoBootstrap() {
        if (!customElements.get('pf-badge')) {
            const component = createCustomElement(Components.Badge, {
                injector: this.injector,
            });
            customElements.define('pf-badge', component);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Badge, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.1", type: Badge, selector: "pf-badge", inputs: { class: "class", id: "id", pill: "pill", size: "size", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
};
Badge = __decorate([
    ProxyCmp({
        inputs: ['class', 'id', 'pill', 'size', 'variant']
    })
], Badge);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Badge, decorators: [{
            type: Component,
            args: [{
                    selector: 'pf-badge',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['class', 'id', 'pill', 'size', 'variant'],
                }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }, { type: i0.Injector }] });
let Button = class Button {
    constructor(c, r, z, injector) {
        this.z = z;
        this.injector = injector;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['click']);
    }
    ngDoBootstrap() {
        if (!customElements.get('pf-button')) {
            const component = createCustomElement(Components.Button, {
                injector: this.injector,
            });
            customElements.define('pf-button', component);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Button, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.1", type: Button, selector: "pf-button", inputs: { block: "block", class: "class", disabled: "disabled", id: "id", loading: "loading", outline: "outline", size: "size", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
};
Button = __decorate([
    ProxyCmp({
        inputs: ['block', 'class', 'disabled', 'id', 'loading', 'outline', 'size', 'variant'],
        methods: ['onClickHandler']
    })
], Button);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Button, decorators: [{
            type: Component,
            args: [{
                    selector: 'pf-button',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['block', 'class', 'disabled', 'id', 'loading', 'outline', 'size', 'variant'],
                }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }, { type: i0.Injector }] });
let Checkbox = class Checkbox {
    constructor(c, r, z, injector) {
        this.z = z;
        this.injector = injector;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['change']);
    }
    ngDoBootstrap() {
        if (!customElements.get('pf-checkbox')) {
            const component = createCustomElement(Components.Checkbox, {
                injector: this.injector,
            });
            customElements.define('pf-checkbox', component);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Checkbox, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.1", type: Checkbox, selector: "pf-checkbox", inputs: { checked: "checked", class: "class", disabled: "disabled", id: "id" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
};
Checkbox = __decorate([
    ProxyCmp({
        inputs: ['checked', 'class', 'disabled', 'id'],
        methods: ['handleOnChange']
    })
], Checkbox);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Checkbox, decorators: [{
            type: Component,
            args: [{
                    selector: 'pf-checkbox',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['checked', 'class', 'disabled', 'id'],
                }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }, { type: i0.Injector }] });
let Dropdown = class Dropdown {
    constructor(c, r, z, injector) {
        this.z = z;
        this.injector = injector;
        c.detach();
        this.el = r.nativeElement;
    }
    ngDoBootstrap() {
        if (!customElements.get('pf-dropdown')) {
            const component = createCustomElement(Components.Dropdown, {
                injector: this.injector,
            });
            customElements.define('pf-dropdown', component);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Dropdown, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.1", type: Dropdown, selector: "pf-dropdown", inputs: { class: "class", disabled: "disabled", hideArrow: "hideArrow", id: "id", isOpen: "isOpen", openOnButtonClick: "openOnButtonClick", size: "size" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
};
Dropdown = __decorate([
    ProxyCmp({
        inputs: ['class', 'disabled', 'hideArrow', 'id', 'isOpen', 'openOnButtonClick', 'size'],
        methods: ['handleOnButtonClick', 'openDropdown', 'closeDropdown', 'toggleDropdown', 'calculateFixedStyles']
    })
], Dropdown);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Dropdown, decorators: [{
            type: Component,
            args: [{
                    selector: 'pf-dropdown',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['class', 'disabled', 'hideArrow', 'id', 'isOpen', 'openOnButtonClick', 'size'],
                }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }, { type: i0.Injector }] });
let Image = class Image {
    constructor(c, r, z, injector) {
        this.z = z;
        this.injector = injector;
        c.detach();
        this.el = r.nativeElement;
    }
    ngDoBootstrap() {
        if (!customElements.get('pf-image')) {
            const component = createCustomElement(Components.Image, {
                injector: this.injector,
            });
            customElements.define('pf-image', component);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Image, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.1", type: Image, selector: "pf-image", inputs: { alt: "alt", class: "class", disabled: "disabled", fallbackSrc: "fallbackSrc", height: "height", id: "id", loading: "loading", rounded: "rounded", src: "src", width: "width" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
};
Image = __decorate([
    ProxyCmp({
        inputs: ['alt', 'class', 'disabled', 'fallbackSrc', 'height', 'id', 'loading', 'rounded', 'src', 'width'],
        methods: ['getImageUrl', 'onImageLoad', 'onImageError']
    })
], Image);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Image, decorators: [{
            type: Component,
            args: [{
                    selector: 'pf-image',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['alt', 'class', 'disabled', 'fallbackSrc', 'height', 'id', 'loading', 'rounded', 'src', 'width'],
                }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }, { type: i0.Injector }] });
let Input = class Input {
    constructor(c, r, z, injector) {
        this.z = z;
        this.injector = injector;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['change']);
    }
    ngDoBootstrap() {
        if (!customElements.get('pf-input')) {
            const component = createCustomElement(Components.Input, {
                injector: this.injector,
            });
            customElements.define('pf-input', component);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Input, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.1", type: Input, selector: "pf-input", inputs: { block: "block", class: "class", disabled: "disabled", id: "id", invalid: "invalid", name: "name", placeholder: "placeholder", size: "size", type: "type", valid: "valid", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
};
Input = __decorate([
    ProxyCmp({
        inputs: ['block', 'class', 'disabled', 'id', 'invalid', 'name', 'placeholder', 'size', 'type', 'valid', 'value'],
        methods: ['onChangeHandler']
    })
], Input);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Input, decorators: [{
            type: Component,
            args: [{
                    selector: 'pf-input',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['block', 'class', 'disabled', 'id', 'invalid', 'name', 'placeholder', 'size', 'type', 'valid', 'value'],
                }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }, { type: i0.Injector }] });
let Select = class Select {
    constructor(c, r, z, injector) {
        this.z = z;
        this.injector = injector;
        c.detach();
        this.el = r.nativeElement;
        proxyOutputs(this, this.el, ['change']);
    }
    ngDoBootstrap() {
        if (!customElements.get('pf-select')) {
            const component = createCustomElement(Components.Select, {
                injector: this.injector,
            });
            customElements.define('pf-select', component);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Select, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.1", type: Select, selector: "pf-select", inputs: { block: "block", class: "class", disabled: "disabled", id: "id", invalid: "invalid", options: "options", size: "size", valid: "valid", value: "value" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
};
Select = __decorate([
    ProxyCmp({
        inputs: ['block', 'class', 'disabled', 'id', 'invalid', 'options', 'size', 'valid', 'value'],
        methods: ['onChangeHandler']
    })
], Select);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Select, decorators: [{
            type: Component,
            args: [{
                    selector: 'pf-select',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['block', 'class', 'disabled', 'id', 'invalid', 'options', 'size', 'valid', 'value'],
                }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }, { type: i0.Injector }] });
let Spinner = class Spinner {
    constructor(c, r, z, injector) {
        this.z = z;
        this.injector = injector;
        c.detach();
        this.el = r.nativeElement;
    }
    ngDoBootstrap() {
        if (!customElements.get('pf-spinner')) {
            const component = createCustomElement(Components.Spinner, {
                injector: this.injector,
            });
            customElements.define('pf-spinner', component);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Spinner, deps: [{ token: i0.ChangeDetectorRef }, { token: i0.ElementRef }, { token: i0.NgZone }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.2.1", type: Spinner, selector: "pf-spinner", inputs: { class: "class", id: "id", type: "type", variant: "variant" }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
};
Spinner = __decorate([
    ProxyCmp({
        inputs: ['class', 'id', 'type', 'variant']
    })
], Spinner);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: Spinner, decorators: [{
            type: Component,
            args: [{
                    selector: 'pf-spinner',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-content></ng-content>',
                    // eslint-disable-next-line @angular-eslint/no-inputs-metadata-property
                    inputs: ['class', 'id', 'type', 'variant'],
                }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }, { type: i0.ElementRef }, { type: i0.NgZone }, { type: i0.Injector }] });

const DIRECTIVES = [
    Badge,
    Button,
    Checkbox,
    Dropdown,
    Image,
    Input,
    Select,
    Spinner
];

class ProfabricComponentsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: ProfabricComponentsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.2.1", ngImport: i0, type: ProfabricComponentsModule, declarations: [Badge, Button, Checkbox, Dropdown, Image, Input, Select, Spinner], imports: [CommonModule], exports: [Badge, Button, Checkbox, Dropdown, Image, Input, Select, Spinner] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: ProfabricComponentsModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.2.1", ngImport: i0, type: ProfabricComponentsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule],
                    declarations: [...DIRECTIVES],
                    exports: [...DIRECTIVES],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { Badge, Button, Checkbox, DIRECTIVES, Dropdown, Image, Input, ProfabricComponentsModule, Select, Spinner };
//# sourceMappingURL=profabric-angular-components.mjs.map
